#define INCL_WINTRACKRECT
#define INCL_WINWINDOWMGR
#define INCL_WINFRAMEMGR
#define INCL_WININPUT
#define INCL_WINPOINTERS
#define INCL_WINMENUS
#define INCL_WINHELP
#define INCL_WINSYS
#define INCL_WINSHELLDATA
#define INCL_BITMAPFILEFORMAT
#define INCL_GPILCIDS
#define INCL_GPIBITMAPS
#define INCL_GPIPRIMITIVES
#include "mg.h"
#include <stdio.h>
#include <string.h>

#define PRO_NAME                "Magnify"
#define PROKEY_VERSION          "Version"
#define PROKEY_POSITION         "Restore Position"
#define PROKEY_VIEWSIZE         "Viewport Size"

MRESULT EXPENTRY newFrameProc(HWND hwnd,USHORT msg,MPARAM mp1,MPARAM mp2)
{
   static PFNWP oldProc;

   switch (msg) {
   case MYM_REGISTER:
      oldProc=(PFNWP)PVOIDFROMMP(mp1);
      return (MRESULT)FALSE;
      break;
   case WM_QUERYTRACKINFO:
      {
         PTRACKINFO pti;
         POINTL minPtl;
         SWP swp;

         WinQueryWindowPos(hwnd,&swp);

         if (swp.fs & SWP_MINIMIZE) {
            return (*oldProc)(hwnd,msg,mp1,mp2);
         } /* endif */

         (*oldProc)(hwnd,msg,mp1,mp2);

         minPtl.x=cxScreen/4;
         minPtl.y=cyScreen/4;

         pti=(PTRACKINFO)PVOIDFROMMP(mp2);
         pti->ptlMinTrackSize=minPtl;

         return (MRESULT)TRUE;
      }
      break;
   default:
      break;
   } /* endswitch */

   return (*oldProc)(hwnd,msg,mp1,mp2);
}

MRESULT EXPENTRY mainWinProc(HWND hwnd,USHORT msg,MPARAM mp1,MPARAM mp2)
{
   switch (msg) {
   case WM_CREATE:
      {
         HPS hps;
         SIZEF sizef;
         HWND hwndParent;
         HWND hwndSysMenu;
         MENUITEM menuItem;
         HBITMAP hHelp;
         HBITMAP hSave;
         USHORT nextPos;
         ULONG cxMenuItem;
         ULONG cyMenuItem;

         WinPostMsg(hwnd,MYM_REFRESH,0L,0L);

         cxMenuItem=WinQuerySysValue(HWND_DESKTOP,SV_CXMINMAXBUTTON)/2;
         cyMenuItem=WinQuerySysValue(HWND_DESKTOP,SV_CYMINMAXBUTTON);

         hps=WinGetPS(hwnd);
         GpiQueryCharBox(hps,&sizef);
         hHelp=GpiLoadBitmap(hps,NULL,MI_HELP,cxMenuItem,cyMenuItem);
         hSave=GpiLoadBitmap(hps,NULL,MI_SAVE,cxMenuItem,cyMenuItem);
         WinReleasePS(hps);

         if ((hHelp==GPI_ERROR) || (hSave==GPI_ERROR)) {
            return (MRESULT)TRUE;
         } /* endif */

         cxChar=HIUSHORT(sizef.cx);
         cyChar=HIUSHORT(sizef.cy);

         hwndView=WinCreateWindow(hwnd,
                                  MAGVW_CLASS,
                                  "",
                                  WS_VISIBLE,
                                  0,
                                  0,
                                  0,
                                  0,
                                  hwnd,
                                  HWND_TOP,
                                  WND_VIEW,
                                  NULL,
                                  NULL);
         hwndStats=WinCreateWindow(hwnd,
                                   MAGST_CLASS,
                                   "",
                                   WS_VISIBLE,
                                   0,
                                   0,
                                   0,
                                   0,
                                   hwnd,
                                   HWND_TOP,
                                   WND_STATS,
                                   NULL,
                                   NULL);
         if ((hwndView==NULL) || (hwndStats==NULL)) {
            return (MRESULT)TRUE;
         } /* endif */

         hwndParent=WinQueryWindow(hwnd,QW_PARENT,FALSE);
         hwndSysMenu=WinWindowFromID(hwndParent,FID_SYSMENU);

         nextPos=1;

         if (hwndHelpMgr!=NULL) {
            menuItem.iPosition=nextPos;
            menuItem.afStyle=MS_TITLEBUTTON | MIS_BITMAP | MIS_HELP;
            menuItem.afAttribute=0;
            menuItem.id=MI_HELP;
            menuItem.hwndSubMenu=NULL;
            menuItem.hItem=(ULONG)hHelp;
            WinSendMsg(hwndSysMenu,
                       MM_INSERTITEM,
                       MPFROMP(&menuItem),
                       MPFROMP(""));

            nextPos++;
         } /* endif */

         menuItem.iPosition=nextPos;
         menuItem.afStyle=MS_TITLEBUTTON | MIS_BITMAP;
         menuItem.afAttribute=0;
         menuItem.id=MI_SAVE;
         menuItem.hwndSubMenu=NULL;
         menuItem.hItem=(ULONG)hSave;
         WinSendMsg(hwndSysMenu,
                    MM_INSERTITEM,
                    MPFROMP(&menuItem),
                    MPFROMP(""));

         WinSendMsg(hwndParent,WM_UPDATEFRAME,MPFROMSHORT(FCF_SYSMENU),0L);
      }
      break;
   case MYM_REFRESH:
      {
         USHORT sizeData;
         CHAR buf[64];
         POINTS restPos;
         POINTS restSize;
         POINTS minPos;
         USHORT swpFlags;

         mousePos.x=32;
         mousePos.y=32;
         magnify=FALSE;

         sizeData=sizeof(buf);
         if (WinQueryProfileData(hab,
                                 PRO_NAME,
                                 PROKEY_POSITION,
                                 buf,
                                 &sizeData)==FALSE) {
            WinSetWindowPos(hwndFrame,
                            NULL,
                            0,
                            0,
                            (SHORT)cxScreen/4,
                            (SHORT)cyScreen/4,
                            SWP_MOVE | SWP_SIZE);

            centerWindow(hwndFrame);
         } else {
            sscanf(buf,
                   "%d %d %d %d %d %d %d",
                   &restPos.x,
                   &restPos.y,
                   &restSize.x,
                   &restSize.y,
                   &minPos.x,
                   &minPos.y,
                   &swpFlags);

            if (swpFlags & SWP_RESTORE) {
               WinSetWindowPos(hwndFrame,
                               NULL,
                               restPos.x,
                               restPos.y,
                               restSize.x,
                               restSize.y,
                               SWP_MOVE | SWP_SIZE);
               WinSetWindowUShort(hwndFrame,QWS_XMINIMIZE,minPos.x);
               WinSetWindowUShort(hwndFrame,QWS_YMINIMIZE,minPos.y);
            } else {
               WinSetWindowUShort(hwndFrame,QWS_XMINIMIZE,minPos.x);
               WinSetWindowUShort(hwndFrame,QWS_YMINIMIZE,minPos.y);

               WinSetWindowPos(hwndFrame,NULL,0,0,0,0,swpFlags);

               WinSetWindowUShort(hwndFrame,QWS_XRESTORE,restPos.x);
               WinSetWindowUShort(hwndFrame,QWS_YRESTORE,restPos.y);
               WinSetWindowUShort(hwndFrame,QWS_CXRESTORE,restSize.x);
               WinSetWindowUShort(hwndFrame,QWS_CYRESTORE,restSize.y);
            } /* endif */
         } /* endif */

         sizeData=sizeof(viewSize);
         if (WinQueryProfileData(hab,
                                 PRO_NAME,
                                 PROKEY_VIEWSIZE,
                                 &viewSize,
                                 &sizeData)==FALSE) {
            viewSize.cx=mousePos.x;
            viewSize.cy=mousePos.y;
         } /* endif */

         WinShowWindow(hwndFrame,TRUE);
         WinSetFocus(HWND_DESKTOP,hwndView);
      }
      break;
   case WM_SAVEAPPLICATION:
      {
         SWP swp;
         CHAR buf[64];

         WinWriteProfileData(hab,
                             PRO_NAME,
                             PROKEY_VERSION,
                             VERSION,
                             strlen(VERSION)+1);

         WinQueryWindowPos(hwndFrame,&swp);
         swp.fs=swp.fs & (SWP_RESTORE | SWP_MINIMIZE | SWP_MAXIMIZE);

         if (swp.fs & SWP_RESTORE) {
            sprintf(buf,
                    "%d %d %d %d %d %d %d",
                    swp.x,
                    swp.y,
                    swp.cx,
                    swp.cy,
                    WinQueryWindowUShort(hwndFrame,QWS_XMINIMIZE),
                    WinQueryWindowUShort(hwndFrame,QWS_YMINIMIZE),
                    swp.fs);
         } else {
            sprintf(buf,
                    "%d %d %d %d %d %d %d",
                    WinQueryWindowUShort(hwndFrame,QWS_XRESTORE),
                    WinQueryWindowUShort(hwndFrame,QWS_YRESTORE),
                    WinQueryWindowUShort(hwndFrame,QWS_CXRESTORE),
                    WinQueryWindowUShort(hwndFrame,QWS_CYRESTORE),
                    WinQueryWindowUShort(hwndFrame,QWS_XMINIMIZE),
                    WinQueryWindowUShort(hwndFrame,QWS_YMINIMIZE),
                    swp.fs);
         } /* endif */

         WinWriteProfileData(hab,
                             PRO_NAME,
                             PROKEY_POSITION,
                             buf,
                             strlen(buf)+1);
         WinWriteProfileData(hab,
                             PRO_NAME,
                             PROKEY_VIEWSIZE,
                             &viewSize,
                             sizeof(viewSize));
      }
      break;
   case WM_SIZE:
      {
         USHORT cx;
         USHORT cy;

         cx=SHORT1FROMMP(mp2);
         cy=SHORT2FROMMP(mp2);

         WinSetWindowPos(hwndView,
                         NULL,
                         0,
                         cyChar*2,
                         cx,
                         cy-cyChar*2,
                         SWP_SIZE|SWP_MOVE);
         WinSetWindowPos(hwndStats,
                         NULL,
                         0,
                         0,
                         cx,
                         cyChar*2,
                         SWP_SIZE|SWP_MOVE);
      }
      break;
   case WM_PAINT:
      {
         HPS hps;

         hps=WinBeginPaint(hwnd,NULL,NULL);
         WinEndPaint(hps);
      }
      break;
   case WM_COMMAND:
      switch (SHORT1FROMMP(mp1)) {
      case MI_SAVE:
         {
            IMAGE image;
            FILE *pFile;
            RECTL sourceRectl;
            ULONG cxImage;
            ULONG cyImage;

            if (WinDlgBox(HWND_DESKTOP,
                          hwnd,
                          fNameDlgProc,
                          NULL,
                          DLG_FNAME,
                          &image)) {

               pFile=fopen(image.fileName,"r");
               if (pFile!=NULL) {
                  fclose(pFile);

                  if (wprintf(hwnd,
                              WP_YESNO,
                              "Continue?",
                              "Overwrite existing %s?",
                              image.fileName)==MBID_NO) {
                     return (MRESULT)FALSE;
                  } /* endif */
               } /* endif */

               sourceRectl.xLeft=0;
               sourceRectl.yBottom=0;
               sourceRectl.xRight=viewSize.cx;
               sourceRectl.yTop=viewSize.cy;

               WinSetPointer(HWND_DESKTOP,hWait);

               switch (image.fileType) {
               case IMG_ICON:
                  cxImage=WinQuerySysValue(HWND_DESKTOP,SV_CXICON);
                  cyImage=WinQuerySysValue(HWND_DESKTOP,SV_CYICON);

                  if (((sourceRectl.xRight!=cxImage) ||
                      (sourceRectl.yTop!=cyImage)) &&
                      (wprintf(hwnd,
                               WP_YESNO,
                               "Improper Size",
                               "The size of the image is not equal\n"
                               "to the size of a \"standard\"\n"
                               "icon (%ld x %ld).  Continue with\n"
                               "saving to a file?",
                               cxImage,
                               cyImage)==MBID_NO)) {
                     return (MRESULT)FALSE;
                  } /* endif */

                  saveImageIco(image.fileName,
                               hpsMemory,
                               &sourceRectl,
                               &image.hotSpot);
                  break;
               case IMG_POINTER:
                  cxImage=WinQuerySysValue(HWND_DESKTOP,SV_CXPOINTER);
                  cyImage=WinQuerySysValue(HWND_DESKTOP,SV_CYPOINTER);

                  if (((sourceRectl.xRight!=cxImage) ||
                      (sourceRectl.yTop!=cyImage)) &&
                      (wprintf(hwnd,
                               WP_YESNO,
                               "Improper Size",
                               "The size of the image is not equal\n"
                               "to the size of a \"standard\"\n"
                               "pointer (%ld x %ld).  Continue with\n"
                               "saving to a file?",
                               cxImage,
                               cyImage)==MBID_NO)) {
                     return (MRESULT)FALSE;
                  } /* endif */

                  saveImagePtr(image.fileName,
                               hpsMemory,
                               &sourceRectl,
                               &image.hotSpot);
                  break;
               case IMG_BITMAP:
                  saveImageBmp(image.fileName,hpsMemory,&sourceRectl);
                  break;
               default:
                  break;
               } /* endswitch */

               WinSetPointer(HWND_DESKTOP,hArrow);
            } /* endif */
         }
         break;
      default:
         break;
      } /* endswitch */
      break;
   case WM_HELP:
      if (hwndHelpMgr!=NULL) {
         switch (SHORT1FROMMP(mp1)) {
         case MI_HELP:
            WinSendMsg(hwndHelpMgr,HM_EXT_HELP,0L,0L);
            break;
         default:
            return WinDefWindowProc(hwnd,msg,mp1,mp2);
         } /* endswitch */
      } /* endif */
      break;
   case HM_QUERY_KEYS_HELP:
      return (MRESULT)KEYHLP_MAIN;
      break;
   default:
      return WinDefWindowProc(hwnd,msg,mp1,mp2);
   } /* endswitch */

   return (MRESULT)FALSE;
}

VOID main(VOID)
{
   ULONG fCreate=FCF_SYSMENU | FCF_TITLEBAR | FCF_MINMAX |
                 FCF_SIZEBORDER | FCF_ICON | FCF_ACCELTABLE;
   HMQ hmq;
   QMSG qmsg;
   SWCNTRL swcntrl;
   CHAR titleText[256];
   PFNWP oldFrameProc;
   HELPINIT helpInit;

   sprintf(titleText,"Magnify version %s",VERSION);

   hab=WinInitialize(NULL);
   hmq=WinCreateMsgQueue(hab,0);

   hArrow=WinQuerySysPointer(HWND_DESKTOP,SPTR_ARROW,FALSE);
   hWait=WinQuerySysPointer(HWND_DESKTOP,SPTR_WAIT,FALSE);

   helpInit.cb=sizeof(HELPINIT);
   helpInit.ulReturnCode=0L;
   helpInit.pszTutorialName=NULL;
   helpInit.phtHelpTable=(PVOID)(0xFFFF0000|WND_MAIN);
   helpInit.hmodHelpTableModule=NULL;
   helpInit.hmodAccelActionBarModule=NULL;
   helpInit.idAccelTable=NULL;
   helpInit.idActionBar=NULL;
   helpInit.pszHelpWindowTitle="Magnify Help";
   helpInit.usShowPanelId=FALSE;
   helpInit.pszHelpLibraryName="MAGNIFY.HLP";

   hwndHelpMgr=WinCreateHelpInstance(hab,&helpInit);
   if (hwndHelpMgr==NULL) {
      wprintf(HWND_DESKTOP,
              WP_OK,
              "No Help",
              "An error occurred while installing\n"
              "Magnify help.  No help will be\n"
              "provided for this session of Magnify.");
   } else
   if (helpInit.ulReturnCode!=0) {
      wprintf(HWND_DESKTOP,
              WP_OK,
              "No Help",
              "An error occurred while installing\n"
              "Magnify help.  No help will be\n"
              "provided for this session of Magnify.");

      WinDestroyHelpInstance(hwndHelpMgr);
      hwndHelpMgr=NULL;
   } /* endif */

   cxScreen=WinQuerySysValue(HWND_DESKTOP,SV_CXSCREEN);
   cyScreen=WinQuerySysValue(HWND_DESKTOP,SV_CYSCREEN);

   WinRegisterClass(hab,MAG_CLASS,mainWinProc,CS_SIZEREDRAW,0);
   WinRegisterClass(hab,MAGVW_CLASS,viewWinProc,CS_SIZEREDRAW,0);
   WinRegisterClass(hab,MAGST_CLASS,statsWinProc,CS_SIZEREDRAW,0);

   hwndFrame=WinCreateStdWindow(HWND_DESKTOP,
                                0L,
                                &fCreate,
                                MAG_CLASS,
                                titleText,
                                0L,
                                NULL,
                                WND_MAIN,
                                &hwndClient);
   if (hwndFrame!=NULL) {
      oldFrameProc=getWindowProc(hwndFrame);
      newFrameProc(NULL,MYM_REGISTER,MPFROMP(oldFrameProc),0L);
      WinSubclassWindow(hwndFrame,newFrameProc);

      swcntrl.hwnd=hwndFrame;
      sprintf(swcntrl.szSwtitle,titleText);
      WinAddSwitchEntry(&swcntrl);

      while (WinGetMsg(hab,&qmsg,NULL,0,0)) {
         WinDispatchMsg(hab,&qmsg);
      } /* endwhile */

      WinDestroyWindow(hwndFrame);
   } /* endif */

   if (hwndHelpMgr!=NULL) {
      WinDestroyHelpInstance(hwndHelpMgr);
   } /* endif */

   WinDestroyMsgQueue(hmq);
   WinTerminate(hab);
}
