#define INCL_WINWINDOWMGR
#define INCL_WININPUT
#define INCL_WINRECTANGLES
#define INCL_WINPOINTERS
#define INCL_WINTIMER
#define INCL_GPILCIDS
#define INCL_GPIPRIMITIVES
#define INCL_GPIBITMAPS
#include "mg.h"
#include <stdio.h>
#include <string.h>

static HPOINTER hMagnify;

MRESULT EXPENTRY viewWinProc(HWND hwnd,USHORT msg,MPARAM mp1,MPARAM mp2)
{
   switch (msg) {
   case WM_CREATE:
      {
         SIZEL sizel;
         POINTL pointl[2];
         UCHAR headerBuf[sizeof(BITMAPINFOHEADER)+sizeof(RGB)*256];
         PBITMAPINFOHEADER pBmih=(PBITMAPINFOHEADER)headerBuf;

         hMagnify=WinLoadPointer(HWND_DESKTOP,NULL,WND_VIEW);
         if (hMagnify==NULL) {
            return (MRESULT)TRUE;
         } /* endif */

         hdcMemory=DevOpenDC(hab,OD_MEMORY,"*",0L,NULL,NULL);
         DevQueryCaps(hdcMemory,
                      CAPS_COLOR_PLANES,
                      1L,
                      &colorPlanes);
         DevQueryCaps(hdcMemory,
                      CAPS_COLOR_BITCOUNT,
                      1L,
                      &colorBitCount);

         sizel.cx=cxScreen;
         sizel.cy=cyScreen;
         hpsMemory=GpiCreatePS(hab,
                               hdcMemory,
                               &sizel,
                               PU_PELS|GPIF_DEFAULT|GPIT_MICRO|GPIA_ASSOC);

         pBmih->cbFix=sizeof(BITMAPINFOHEADER);
         pBmih->cx=(SHORT)cxScreen;
         pBmih->cy=(SHORT)cyScreen;
         pBmih->cPlanes=(SHORT)colorPlanes;
         pBmih->cBitCount=(SHORT)colorBitCount;

         hbmMemory=GpiCreateBitmap(hpsMemory,pBmih,0L,0L,NULL);
         if (hbmMemory==NULL) {
            GpiDestroyPS(hpsMemory);
            DevCloseDC(hdcMemory);
            return (MRESULT)TRUE;
         } /* endif */

         GpiSetBitmap(hpsMemory,hbmMemory);

         pointl[0].x=0;
         pointl[0].y=0;
         pointl[1].x=cxScreen;
         pointl[1].y=cyScreen;

         GpiBitBlt(hpsMemory,NULL,2L,pointl,ROP_ZERO,BBO_IGNORE);
      }
      break;
   case WM_DESTROY:
      GpiDeleteBitmap(hbmMemory);
      GpiDestroyPS(hpsMemory);
      DevCloseDC(hdcMemory);
      break;
   case WM_BUTTON1DBLCLK:
      if (!magnify) {
         magnify=TRUE;
         WinSetFocus(HWND_DESKTOP,hwnd);
         WinSetCapture(HWND_DESKTOP,hwnd);
         WinStartTimer(hab,hwnd,TID_REFRESH,250);
      } else {
         WinStopTimer(hab,hwnd,TID_REFRESH);
         WinSetCapture(HWND_DESKTOP,NULL);
         magnify=FALSE;
      } /* endif */
      break;
   case WM_CHAR:
      {
         USHORT charFlags;

         charFlags=CHARMSG(&msg)->fs;

         if (((charFlags & KC_KEYUP)==0) || ((charFlags & KC_PREVDOWN)!=0)) {
            SHORT incX;
            SHORT incY;

            switch (CHARMSG(&msg)->vkey) {
            case VK_LEFT:
               incX=-1;
               incY=0;
               break;
            case VK_RIGHT:
               incX=1;
               incY=0;
               break;
            case VK_UP:
               incX=0;
               incY=1;
               break;
            case VK_DOWN:
               incX=0;
               incY=-1;
               break;
            case VK_HOME:
               incX=-1;
               incY=1;
               break;
            case VK_END:
               incX=-1;
               incY=-1;
               break;
            case VK_PAGEUP:
               incX=1;
               incY=1;
               break;
            case VK_PAGEDOWN:
               incX=1;
               incY=-1;
               break;
            case VK_NEWLINE:
            case VK_ENTER:
               WinSendMsg(hwnd,WM_BUTTON1DBLCLK,0L,0L);
               return (MRESULT)FALSE;
               break;
            default:
               incX=0;
               incY=0;
               break;
            } /* endswitch */

            if (charFlags & KC_CTRL) {
               incX*=MAX_X;
               incY*=MAX_Y;
            } else
            if (charFlags & KC_ALT) {
               incX*=4;
               incY*=4;
            } /* endif */

            viewSize.cx+=incX;
            viewSize.cy+=incY;

            if (viewSize.cx<MIN_X) {
               viewSize.cx=MIN_X;
            } else
            if (viewSize.cx>MAX_X) {
               viewSize.cx=MAX_X;
            } /* endif */

            if (viewSize.cy<MIN_Y) {
               viewSize.cy=MIN_Y;
            } else
            if (viewSize.cy>MAX_Y) {
               viewSize.cy=MAX_Y;
            } /* endif */

            WinSendMsg(hwndStats,MYM_REFRESH,0L,0L);
         } /* endif */
      }
      break;
   case WM_MOUSEMOVE:
      if (magnify) {
         HWND hwndPoint;
         POINTL pointl;

         pointl.x=SHORT1FROMMP(mp1);
         pointl.y=SHORT2FROMMP(mp1);
         WinMapWindowPoints(hwnd,HWND_DESKTOP,&pointl,1);

         hwndPoint=WinWindowFromPoint(HWND_DESKTOP,&pointl,FALSE,FALSE);

         if (hwndPoint!=hwndFrame) {
            mousePos.x=pointl.x;
            mousePos.y=pointl.y;

            WinSetPointer(HWND_DESKTOP,hMagnify);
         } else {
            WinSetPointer(HWND_DESKTOP,hArrow);
         } /* endif */

         return (MRESULT)TRUE;
      } else {
         return WinDefWindowProc(hwnd,msg,mp1,mp2);
      } /* endif */
      break;
   case WM_TIMER:
      if (SHORT1FROMMP(mp1)==TID_REFRESH) {
         HPS hpsDesktop;
         HPS hps;
         POINTL pointl[4];
         POINTL pointlMemory[4];
         RECTL rectl;

         WinQueryWindowRect(hwnd,&rectl);
         pointl[0].x=rectl.xLeft;
         pointl[0].y=rectl.yBottom;
         pointl[1].x=rectl.xRight;
         pointl[1].y=rectl.yTop;
         pointl[2].x=mousePos.x-viewSize.cx/2;
         pointl[2].y=mousePos.y-viewSize.cy/2;
         pointl[3].x=mousePos.x+viewSize.cx/2;
         pointl[3].y=mousePos.y+viewSize.cy/2;

         pointlMemory[0].x=0;
         pointlMemory[0].y=0;
         pointlMemory[1].x=viewSize.cx;
         pointlMemory[1].y=viewSize.cy;
         pointlMemory[2].x=mousePos.x-viewSize.cx/2;
         pointlMemory[2].y=mousePos.y-viewSize.cy/2;
         pointlMemory[3].x=mousePos.x+viewSize.cx/2;
         pointlMemory[3].y=mousePos.y+viewSize.cy/2;

         hpsDesktop=WinGetPS(HWND_DESKTOP);
         hps=WinGetPS(hwnd);

         GpiBitBlt(hps,hpsDesktop,4L,pointl,ROP_SRCCOPY,BBO_IGNORE);
         GpiBitBlt(hpsMemory,hpsDesktop,4L,pointlMemory,ROP_SRCCOPY,BBO_IGNORE);

         WinReleasePS(hps);
         WinReleasePS(hpsDesktop);
      } /* endif */
      break;
   case WM_PAINT:
      {
         HPS hps;
         POINTL pointl[4];
         RECTL rectl;

         WinQueryWindowRect(hwnd,&rectl);
         pointl[0].x=rectl.xLeft;
         pointl[0].y=rectl.yBottom;
         pointl[1].x=rectl.xRight;
         pointl[1].y=rectl.yTop;
         pointl[2].x=0;
         pointl[2].y=0;
         pointl[3].x=viewSize.cx;
         pointl[3].y=viewSize.cy;

         hps=WinBeginPaint(hwnd,NULL,NULL);
         GpiBitBlt(hps,hpsMemory,4L,pointl,ROP_SRCCOPY,BBO_IGNORE);
         WinEndPaint(hps);
      }
      break;
   default:
      return WinDefWindowProc(hwnd,msg,mp1,mp2);
   } /* endswitch */

   return (MRESULT)FALSE;
}

MRESULT EXPENTRY statsWinProc(HWND hwnd,USHORT msg,MPARAM mp1,MPARAM mp2)
{
   switch (msg) {
   case MYM_REFRESH:
      {
         HPS hps;
         RECTL rectl;
         CHAR buf[32];

         hps=WinGetPS(hwnd);

         sprintf(buf,"View (%ld,%ld)",viewSize.cx,viewSize.cy);
         WinQueryWindowRect(hwnd,&rectl);
         WinInflateRect(hab,&rectl,-cxChar,-cyChar/4);
         WinFillRect(hps,&rectl,CLR_WHITE);
         WinDrawText(hps,
                     strlen(buf),
                     buf,
                     &rectl,
                     CLR_BLACK,
                     0L,
                     DT_LEFT|DT_VCENTER);

         WinReleasePS(hps);
      }
      break;
   case WM_PAINT:
      {
         HPS hps;
         RECTL rectl;

         WinQueryWindowRect(hwnd,&rectl);
         rectl.xRight--;
         rectl.yTop--;

         hps=WinBeginPaint(hwnd,NULL,NULL);

         GpiErase(hps);
         GpiSetColor(hps,CLR_BLACK);
         GpiMove(hps,(PPOINTL)&rectl.xLeft);
         GpiBox(hps,DRO_OUTLINE,(PPOINTL)&rectl.xRight,0L,0L);

         WinEndPaint(hps);

         WinSendMsg(hwnd,MYM_REFRESH,0L,0L);
      }
      break;
   default:
      return WinDefWindowProc(hwnd,msg,mp1,mp2);
   } /* endswitch */

   return (MRESULT)FALSE;
}

