#define INCL_WINDIALOGS
#define INCL_WINBUTTONS
#define INCL_WINENTRYFIELDS
#define INCL_WINHELP
#include "mg.h"
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

static PIMAGE pImage;

MRESULT EXPENTRY fNameDlgProc(HWND hwnd,USHORT msg,MPARAM mp1,MPARAM mp2)
{
   switch (msg) {
   case WM_INITDLG:
      pImage=(PIMAGE)mp2;

      centerWindow(hwnd);

      WinSendDlgItemMsg(hwnd,
                        FN_EF_NAME,
                        EM_SETTEXTLIMIT,
                        MPFROMSHORT(sizeof(pImage->fileName)),
                        0L);
      WinSendDlgItemMsg(hwnd,
                        FN_EF_HOTX,
                        EM_SETTEXTLIMIT,
                        MPFROMSHORT(3),
                        0L);
      WinSendDlgItemMsg(hwnd,
                        FN_EF_HOTY,
                        EM_SETTEXTLIMIT,
                        MPFROMSHORT(3),
                        0L);

      WinSendDlgItemMsg(hwnd,FN_RB_BITMAP,BM_CLICK,MPFROMSHORT(TRUE),0L);

      if (hwndHelpMgr!=NULL) {
         WinAssociateHelpInstance(hwndHelpMgr,hwnd);
      } /* endif */
      break;
   case WM_DESTROY:
      if (hwndHelpMgr!=NULL) {
         WinAssociateHelpInstance(NULL,hwnd);
      } /* endif */
      break;
   case WM_CONTROL:
      switch (SHORT1FROMMP(mp1)) {
      case FN_RB_ICON:
      case FN_RB_POINTER:
         WinEnableWindow(WinWindowFromID(hwnd,FN_EF_HOTX),TRUE);
         WinEnableWindow(WinWindowFromID(hwnd,FN_EF_HOTY),TRUE);
         break;
      case FN_RB_BITMAP:
         WinEnableWindow(WinWindowFromID(hwnd,FN_EF_HOTX),FALSE);
         WinEnableWindow(WinWindowFromID(hwnd,FN_EF_HOTY),FALSE);
         break;
      default:
         break;
      } /* endswitch */
      break;
   case WM_COMMAND:
      switch (SHORT1FROMMP(mp1)) {
      case DID_OK:
      case PB_OKAY:
         {
            CHAR buf[4];
            USHORT index;

            WinQueryDlgItemText(hwnd,
                                FN_EF_NAME,
                                sizeof(pImage->fileName),
                                pImage->fileName);
            if (strlen(pImage->fileName)==0) {
               wprintf(hwnd,WP_OK,"Input Required","You must enter a filename.");
               WinSetFocus(HWND_DESKTOP,WinWindowFromID(hwnd,FN_EF_NAME));
               return (MRESULT)FALSE;
            } /* endif */

            pImage->fileType=SHORT1FROMMR(WinSendDlgItemMsg(hwnd,
                                                            FN_RB_ICON,
                                                            BM_QUERYCHECKINDEX,
                                                            0L,
                                                            0L))+IMG_ICON;

            WinQueryDlgItemText(hwnd,FN_EF_HOTX,sizeof(buf),buf);
            if ((strlen(buf)==0) && (pImage->fileType!=IMG_BITMAP)) {
               wprintf(hwnd,
                       WP_OK,
                       "Input Required",
                       "You must enter a value for the\n"
                       "X hotspot.");

               WinSetFocus(HWND_DESKTOP,WinWindowFromID(hwnd,FN_EF_HOTX));
               return (MRESULT)TRUE;
            } /* endif */

            for (index=0; index<strlen(buf); index++) {
               if (!isdigit(buf[index])) {
                  wprintf(hwnd,
                          WP_OK,
                          "Not numeric",
                          "The value entered is not numeric.");

                  WinSetFocus(HWND_DESKTOP,WinWindowFromID(hwnd,FN_EF_HOTX));
                  return (MRESULT)TRUE;
               } /* endif */
            } /* endfor */
            pImage->hotSpot.x=atoi(buf);

            WinQueryDlgItemText(hwnd,FN_EF_HOTY,sizeof(buf),buf);
            if ((strlen(buf)==0) && (pImage->fileType!=IMG_BITMAP)) {
               wprintf(hwnd,
                       WP_OK,
                       "Input Required",
                       "You must enter a value for the\n"
                       "Y hotspot.");

               WinSetFocus(HWND_DESKTOP,WinWindowFromID(hwnd,FN_EF_HOTY));
               return (MRESULT)TRUE;
            } /* endif */

            for (index=0; index<strlen(buf); index++) {
               if (!isdigit(buf[index])) {
                  wprintf(hwnd,
                          WP_OK,
                          "Not numeric",
                          "The value entered is not numeric.");

                  WinSetFocus(HWND_DESKTOP,WinWindowFromID(hwnd,FN_EF_HOTY));
                  return (MRESULT)TRUE;
               } /* endif */
            } /* endfor */
            pImage->hotSpot.y=atoi(buf);

            WinDismissDlg(hwnd,TRUE);
         }
         break;
      case DID_CANCEL:
      case PB_CANCEL:
         WinDismissDlg(hwnd,FALSE);
         break;
      default:
         break;
      } /* endswitch */
      break;
   default:
      return WinDefDlgProc(hwnd,msg,mp1,mp2);
   } /* endswitch */

   return (MRESULT)FALSE;
}
